<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Bootstrap CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta2/dist/css/bootstrap.min.css" rel="stylesheet"
          integrity="sha384-BmbxuPwQa2lc/FVzBcNJ7UAyJxM6wuqIj61tLrc4wSX0szH/Ev+nYRRuWlolflfl" crossorigin="anonymous">
</head>
<body>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta2/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-b5kHyXgcpbZJO/tY9Ul7kGkf1S0CWuKcCD38l8YkeH8z8QjE0GmW1gYU5S9FOnJ0"
        crossorigin="anonymous">
</script>
<script type='text/javascript' src="/js/listen-to-stream.js"></script>

<header>
    <div class="container" id="login-control-box">Fetching you user status…</div>
</header>

<div class="container">
    <h4 style="text-align: center">Available items</h4>
    <form>
        <button type="submit" class="btn btn-primary" formaction="/items/new">
            New Item
        </button>
    </form>
    <div class="table-responsive">
        <table class="table" id="items-table">
            <thead>
            <tr>
                <th>Name</th>
                <th>Price</th>
                <th>Currency</th>
            </tr>
            </thead>
            <tbody></tbody>
        </table>
    </div>
</div>

<script>
    listenToStream("items", function (event) {
        const data = JSON.parse(event.data)

        console.log(data)

        const table = document.getElementById("items-table")
        const row = table.insertRow()
        const cellName = row.insertCell(0)
        const cellPrice = row.insertCell(1)
        const cellCurrency = row.insertCell(2)

        cellName.innerHTML = "<td>" + data.name + "</td>"
        cellPrice.innerHTML = "<td>" + data.price.toFixed(2) + "</td>"
        cellCurrency.innerHTML = "<td>" + data.currency + "</td>"
    })

    const userSource = new EventSource("/api/v1/user")
    userSource.onmessage = function (event) {
        console.log("onmessage")
        const user = JSON.parse(event.data)
        const container = document.getElementById("login-control-box")
        container.innerHTML = `
            ${user.displayName} |
            ${user.preferredCurrency} |
            <a href="/logout">Logout</a>
        `;
        userSource.close()
    }
    userSource.onerror = function () {
        console.log("onerror")
        const container = document.getElementById("login-control-box")
        container.innerHTML = `
            <a href="/enter">Enter</a> |
            <a href="/register">Register</a>
        `;
        userSource.close()
    }
</script>

</body>
</html>